import { APIGatewayProxyEventV2 } from 'aws-lambda';
import { Middleware, ValidationErrorParser } from './types.js';

declare function definePrecognitiveHandler<T>(handlers: {
    before?: Middleware | Middleware[];
    main: (event: APIGatewayProxyEventV2) => Promise<T>;
    after?: Middleware | Middleware[];
}, errorParsers: ValidationErrorParser[]): (event: APIGatewayProxyEventV2) => Promise<{
    statusCode: number;
    headers: {
        'Content-Type': string;
    };
    body: string;
} | {
    statusCode: number;
    headers: {
        'Content-Type': string;
    };
    body?: undefined;
} | T>;

export { definePrecognitiveHandler };
