import { APIGatewayProxyEventV2 } from 'aws-lambda';

type Middleware = (event: APIGatewayProxyEventV2) => Promise<void> | void;
type ValidationErrors = Record<string, string | string[]>;
interface ValidationErrorsData {
    message: string;
    errors: ValidationErrors;
}
type KnownErrorParser = 'ZOD_ERROR_PARSER';
type ValidationErrorParser = ((error: Error) => ValidationErrorsData | undefined | null) | KnownErrorParser;

export type { KnownErrorParser, Middleware, ValidationErrorParser, ValidationErrors, ValidationErrorsData };
